POJ 2395 Out of Hay【求MST中最长边】

来源:互联网 发布:预付款融优化 编辑:程序博客网 时间:2024/06/05 03:44

Out of Hay

Time Limit: 1000MS

 

Memory Limit: 65536K

Total Submissions: 14562

 

Accepted: 5659

Description

The cows have run out of hay, a horrible event that must be remedied immediately. Bessie intends to visit the other farms to survey their hay situation. There are N (2 <= N <= 2,000) farms (numbered 1..N); Bessie starts at Farm 1. She'll traverse some or all of the M (1 <= M <= 10,000) two-way roads whose length does not exceed 1,000,000,000 that connect the farms. Some farms may be multiply connected with different length roads. All farms are connected one way or another to Farm 1. 

Bessie is trying to decide how large a waterskin she will need. She knows that she needs one ounce of water for each unit of length of a road. Since she can get more water at each farm, she's only concerned about the length of the longest road. Of course, she plans her route between farms such that she minimizes the amount of water she must carry. 

Help Bessie know the largest amount of water she will ever have to carry: what is the length of longest road she'll have to travel between any two farms, presuming she chooses routes that minimize that number? This means, of course, that she might backtrack over a road in order to minimize the length of the longest road she'll have to traverse.

Input

* Line 1: Two space-separated integers, N and M. 

* Lines 2..1+M: Line i+1 contains three space-separated integers, A_i, B_i, and L_i, describing a road from A_i to B_i of length L_i.

Output

* Line 1: A single integer that is the length of the longest road required to be traversed.

Sample Input

3 3

1 2 23

2 3 1000

1 3 43

Sample Output

43

Hint

OUTPUT DETAILS: 

In order to reach farm 2, Bessie travels along a road of length 23. To reach farm 3, Bessie travels along a road of length 43. With capacity 43, she can travel along these roads provided that she refills her tank to maximum capacity before she starts down a road.

Source

USACO 2005 March Silver


思路:对m条边排序,使用克鲁斯卡尔算法,对边进行贪心入树,我们知道,一颗最小生成树一定是n-1条边,所以对于这最后一条边,就一定是树种权值最大的一条边。


AC代码:


#include<stdio.h>#include<string.h>#include<algorithm>using namespace std;struct zuobiao{    int x,y,w;}a[121212];int f[121212];int cmp(zuobiao a,zuobiao b){    return a.w<b.w;}int find(int x){    return f[x] == x ? x : (f[x] = find(f[x]));}void merge(int a,int b){    int A,B;    A=find(a);    B=find(b);    if(A!=B)    f[B]=A;}int main(){    int n,m;    while(~scanf("%d%d",&n,&m))    {        for(int i=1;i<=n;i++)f[i]=i;        for(int i=0;i<m;i++)        {            scanf("%d%d%d",&a[i].x,&a[i].y,&a[i].w);        }        int k=0;        sort(a,a+m,cmp);        for(int i=0;i<m;i++)        {            if(find(a[i].x)!=find(a[i].y))            {                merge(a[i].x,a[i].y);                k++;                if(k==n-1)                {                    printf("%d\n",a[i].w);                    break;                }            }        }    }}












0 0
原创粉丝点击